# ScriptFunctions.py - script functions developed by Optibrium for integration with StarDrop software
# Use of this code is subject to the terms of the StarDrop License Agreement and use, copying or redistribution of this file for use by other persons or organisations is prohibited
# Copyright(C) Optibrium Ltd 2016
# stardrop-support@optibrium.com
#

Functions = []
#Add script definitions here, numerical ids must be unique and greater than 100
Functions.append((501,'Retrieve data from D360'))
Functions.append((502,'Refresh D360 workspace list'))


import app
import PythonQt
import certara
	  
def importData(stardrop,view):
	try:
		ds = certara.loadData(view)
		stardrop.exportDS("d360",ds.pack())
		try:
			stardrop.setRefreshKey("",`view`,{})
		except:
			pass
	except Exception, e:
		stardrop.show(e)

def retrieveDataTree(stardrop):
  dlg = PythonQt.FileBrowser()
  dlg.setWindowTitle('D360 Access')
  try:
    reports = certara.getAvailableReports()
    dlg.addDataSets(reports)
  except Exception,e:
    stardrop.show(e)
    return
  
  if dlg.run() == True:
    report = dlg.getSelectedDataSet()
    print 'Selected report is ' + `report`
    importData(stardrop,report)

	
#add to this function to handle each script declared above
#Index is the numerical ID used when declaring the script, and 'stardrop' is the appui module provide by StarDrop
#The function name needs to match that given in user.py
def ScriptFunction(index, stardrop):
	if index == 501:
		retrieveDataTree(stardrop)
	elif index == 502:
		try:
			certara.refreshWorkspaceList()
		except Exception,e:
			stardrop.show(e)
	else:
		print 'Accessing global script ' + `index`	
		
